/*
 * Main.java
 *
 * Created on December 9, 2005, 9:34 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package scanmetainf;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

/**
 *
 * @author edburns
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        File dir = new File(args[0]);
        if (!dir.isDirectory()) {
            printUsage();
            return;
        }
       
        try {
            scanDir(dir);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
   
    
    

    public static void printJarInfo(File file, PrintWriter out) throws IOException {
        JarFile jarFile = new JarFile(file);
        JarEntry manifest = jarFile.getJarEntry("META-INF/MANIFEST.MF");
        if (null == manifest) {
            out.print("No manifest in " + file.toString());
        } else {
            out.print(manifest.toString() + " for " + file.toString());
            InputStream is = jarFile.getInputStream(manifest);
            BufferedReader reader =
                    new BufferedReader(new InputStreamReader(is));
            String cur = null;
            while (null != (cur = reader.readLine())) {
                out.print(cur + " ");
            }
        }
        out.print("\n");
        
        out.flush();
        
    }

    public static void printUsage() {
        System.err.println("Must pass directory containing jars to scan");
    }

    public static void scanDir(File dir) throws IOException {
        File file = null;
        String [] filenames = dir.list();
        for (String cur : filenames) {
            file = new File(dir, cur);
            if (file.isDirectory()) {
                scanDir(file);
            }
            else {
                if (file.getAbsolutePath().endsWith(".jar")) {
                    printJarInfo(file, new PrintWriter(System.out));
                }
            }
        }
        

    }
    
}
